AVL_InitializeGenericTable               equ 0
AVL_InsertElementGenericTable            equ 1
AVL_DeleteElementGenericTable            equ 2
AVL_LookupElementGenericTable            equ 3
AVL_EnumerateGenericTable                equ 4
AVL_EnumerateGenericTableWithoutSplaying equ 5
AVL_GetElementGenericTable               equ 6
AVL_NumberGenericTableElements           equ 7
AVL_IsGenericTableEmpty                  equ 8

RTL_BALANCED_LINKS         struct
Parent                     PVOID ?                        ; PRTL_BALANCED_LINKS
LeftChild                  PVOID ?                        ; PRTL_BALANCED_LINKS
RightChild                 PVOID ?                        ; PRTL_BALANCED_LINKS
;Balance		CHAR ?
;Reserved		UCHAR 3 DUP (?)
RTL_BALANCED_LINKS         ends
PRTL_BALANCED_LINKS        typedef ptr RTL_BALANCED_LINKS

RTL_AVL_TABLE              struct
BalancedRoot               RTL_BALANCED_LINKS <>
OrderedPointer             PVOID ?
WhichOrderedElement        ULONG ?
NumberGenericTableElements ULONG ?
DepthOfTree                ULONG ?
RestartKey                 PRTL_BALANCED_LINKS ?
DeleteCount                ULONG ?
CompareRoutine             PVOID ?                        ; PRTL_AVL_COMPARE_ROUTINE
AllocateRoutine            PVOID ?                        ; PRTL_AVL_ALLOCATE_ROUTINE
FreeRoutine                PVOID ?                        ; PRTL_AVL_FREE_ROUTINE
TableContext               PVOID ?
RTL_AVL_TABLE              ends
PRTL_AVL_TABLE             typedef ptr RTL_AVL_TABLE

RTL_SPLAY_LINKS            struct
Parent                     PVOID ?                        ; PRTL_SPLAY_LINKS
LeftChild                  PVOID ?                        ; PRTL_SPLAY_LINKS
RightChild                 PVOID ?                        ; PRTL_SPLAY_LINKS
RTL_SPLAY_LINKS            ends
PRTL_SPLAY_LINKS           typedef ptr RTL_SPLAY_LINKS

GenericLessThan    equ 0
GenericGreaterThan equ 1
GenericEqual       equ 3

%AVL macro Id
	mov  eax, Id
	Call AVLENTRY
endm

AVLENTRY:
DB 085H, 0C0H, 00FH, 084H, 01BH, 002H, 000H, 000H, 048H, 00FH
DB 084H, 0E6H, 001H, 000H, 000H, 048H, 00FH, 084H, 08CH, 001H
DB 000H, 000H, 048H, 00FH, 084H, 069H, 001H, 000H, 000H, 048H
DB 00FH, 084H, 042H, 001H, 000H, 000H, 048H, 00FH, 084H, 0F5H
DB 000H, 000H, 000H, 048H, 074H, 02AH, 048H, 074H, 018H, 048H
DB 074H, 001H, 0C3H, 08BH, 0FFH, 055H, 08BH, 0ECH, 08BH, 04DH
DB 008H, 033H, 0C0H, 039H, 041H, 018H, 00FH, 094H, 0C0H, 05DH
DB 0C2H, 004H, 000H, 08BH, 0FFH, 055H, 08BH, 0ECH, 08BH, 045H
DB 008H, 08BH, 040H, 018H, 05DH, 0C2H, 004H, 000H, 08BH, 0FFH
DB 055H, 08BH, 0ECH, 053H, 08BH, 05DH, 00CH, 083H, 0FBH, 0FFH
DB 056H, 08BH, 075H, 008H, 08BH, 04EH, 014H, 08BH, 046H, 010H
DB 057H, 08BH, 07EH, 018H, 074H, 05FH, 08DH, 053H, 001H, 03BH
DB 0D7H, 077H, 058H, 085H, 0C0H, 075H, 014H, 08BH, 046H, 008H
DB 0EBH, 002H, 08BH, 0C1H, 08BH, 048H, 004H, 085H, 0C9H, 075H
DB 0F7H, 021H, 04EH, 014H, 089H, 046H, 010H, 03BH, 0CBH, 074H
DB 037H, 076H, 063H, 08BH, 0D1H, 0D1H, 0EAH, 03BH, 0DAH, 072H
DB 03BH, 02BH, 0CBH, 074H, 023H, 08BH, 0D1H, 050H, 0E8H, 0B2H
DB 004H, 000H, 000H, 04AH, 074H, 018H, 0EBH, 0F5H, 08BH, 0C1H
DB 08BH, 048H, 008H, 085H, 0C9H, 075H, 0F7H, 085H, 0FFH, 074H
DB 009H, 050H, 0E8H, 09AH, 004H, 000H, 000H, 04FH, 075H, 0F7H
DB 089H, 046H, 010H, 089H, 05EH, 014H, 083H, 0C0H, 010H, 0EBH
DB 002H, 033H, 0C0H, 05FH, 05EH, 05BH, 05DH, 0C2H, 008H, 000H
DB 08BH, 046H, 008H, 0EBH, 002H, 08BH, 0C1H, 08BH, 048H, 004H
DB 085H, 0C9H, 075H, 0F7H, 085H, 0DBH, 074H, 0DAH, 08BH, 0FBH
DB 050H, 0E8H, 0CAH, 004H, 000H, 000H, 04BH, 04FH, 074H, 0CEH
DB 0EBH, 0F4H, 08BH, 0D3H, 02BH, 0D1H, 02BH, 0FBH, 04FH, 08DH
DB 04FH, 001H, 03BH, 0D1H, 077H, 011H, 085H, 0D2H, 074H, 0BAH
DB 08BH, 0FAH, 050H, 0E8H, 0AAH, 004H, 000H, 000H, 04FH, 074H
DB 0AFH, 0EBH, 0F5H, 08BH, 046H, 008H, 0EBH, 094H, 08BH, 0FFH
DB 055H, 08BH, 0ECH, 08BH, 04DH, 008H, 083H, 079H, 018H, 000H
DB 075H, 006H, 033H, 0C0H, 05DH, 0C2H, 008H, 000H, 056H, 08BH
DB 075H, 00CH, 08BH, 006H, 085H, 0C0H, 075H, 010H, 08BH, 041H
DB 008H, 0EBH, 002H, 08BH, 0C1H, 08BH, 048H, 004H, 085H, 0C9H
DB 074H, 00CH, 0EBH, 0F5H, 050H, 0E8H, 06CH, 004H, 000H, 000H
DB 085H, 0C0H, 074H, 002H, 089H, 006H, 08DH, 048H, 010H, 0F7H
DB 0D8H, 01BH, 0C0H, 023H, 0C1H, 05EH, 0EBH, 0CAH, 08BH, 0FFH
DB 055H, 08BH, 0ECH, 080H, 07DH, 00CH, 000H, 08BH, 045H, 008H
DB 074H, 004H, 083H, 060H, 020H, 000H, 08DH, 048H, 020H, 051H
DB 050H, 0E8H, 09EH, 0FFH, 0FFH, 0FFH, 05DH, 0C2H, 008H, 000H
DB 08BH, 0FFH, 055H, 08BH, 0ECH, 08DH, 045H, 00CH, 050H, 08DH
DB 045H, 008H, 050H, 0FFH, 075H, 00CH, 0FFH, 075H, 008H, 0E8H
DB 0F5H, 003H, 000H, 000H, 05DH, 0C2H, 008H, 000H, 08BH, 0FFH
DB 055H, 08BH, 0ECH, 056H, 08BH, 075H, 008H, 08DH, 045H, 00CH
DB 050H, 0FFH, 075H, 00CH, 056H, 0E8H, 04EH, 002H, 000H, 000H
DB 083H, 0F8H, 001H, 074H, 004H, 032H, 0C0H, 0EBH, 02FH, 057H
DB 08BH, 07DH, 00CH, 03BH, 07EH, 020H, 075H, 009H, 057H, 0E8H
DB 08FH, 003H, 000H, 000H, 089H, 046H, 020H, 0FFH, 046H, 024H
DB 057H, 056H, 0E8H, 07DH, 002H, 000H, 000H, 0FFH, 04EH, 018H
DB 083H, 066H, 014H, 000H, 083H, 066H, 010H, 000H, 057H, 056H
DB 0FFH, 056H, 030H, 0B0H, 001H, 05FH, 05EH, 05DH, 0C2H, 008H
DB 000H, 08BH, 0FFH, 055H, 08BH, 0ECH, 051H, 08DH, 045H, 0FCH
DB 050H, 0FFH, 075H, 00CH, 0FFH, 075H, 008H, 0E8H, 0FCH, 001H
DB 000H, 000H, 050H, 0FFH, 075H, 0FCH, 0FFH, 075H, 014H, 0FFH
DB 075H, 010H, 0FFH, 075H, 00CH, 0FFH, 075H, 008H, 0E8H, 035H
DB 000H, 000H, 000H, 0C9H, 0C2H, 010H, 000H, 08BH, 0FFH, 055H
DB 08BH, 0ECH, 08BH, 055H, 008H, 057H, 033H, 0C0H, 06AH, 00EH
DB 059H, 08BH, 0FAH, 0F3H, 0ABH, 08BH, 045H, 00CH, 089H, 042H
DB 028H, 08BH, 045H, 010H, 089H, 042H, 02CH, 08BH, 045H, 014H
DB 089H, 042H, 030H, 08BH, 045H, 018H, 089H, 012H, 089H, 042H
DB 034H, 05FH, 05DH, 0C2H, 014H, 000H, 08BH, 0FFH, 055H, 08BH
DB 0ECH, 083H, 07DH, 01CH, 001H, 053H, 056H, 074H, 021H, 08BH
DB 045H, 010H, 08BH, 075H, 008H, 083H, 0C0H, 010H, 050H, 056H
DB 0FFH, 056H, 02CH, 08BH, 0D8H, 085H, 0DBH, 075H, 029H, 08BH
DB 045H, 014H, 085H, 0C0H, 074H, 002H, 088H, 018H, 033H, 0C0H
DB 0EBH, 016H, 08BH, 05DH, 018H, 08BH, 045H, 014H, 085H, 0C0H
DB 074H, 009H, 083H, 07DH, 01CH, 001H, 00FH, 095H, 0C1H, 088H
DB 008H, 08DH, 043H, 010H, 05EH, 05BH, 05DH, 0C2H, 018H, 000H
DB 057H, 033H, 0C0H, 08BH, 0FBH, 0ABH, 0ABH, 0ABH, 0ABH, 0FFH
DB 046H, 018H, 083H, 07DH, 01CH, 000H, 075H, 02EH, 089H, 05EH
DB 008H, 089H, 033H, 0C7H, 046H, 01CH, 001H, 000H, 000H, 000H
DB 0EBH, 006H, 050H, 0E8H, 062H, 000H, 000H, 000H, 08BH, 04DH
DB 010H, 08BH, 075H, 00CH, 08BH, 0C1H, 0C1H, 0E9H, 002H, 08DH
DB 07BH, 010H, 0F3H, 0A5H, 08BH, 0C8H, 083H, 0E1H, 003H, 0F3H
DB 0A4H, 05FH, 0EBH, 0A7H, 083H, 07DH, 01CH, 002H, 08BH, 045H
DB 018H, 08BH, 0FBH, 075H, 005H, 089H, 058H, 004H, 0EBH, 003H
DB 089H, 058H, 008H, 089H, 003H, 0C6H, 046H, 00CH, 0FFH, 08BH
DB 017H, 039H, 07AH, 004H, 0B1H, 001H, 075H, 003H, 080H, 0C9H
DB 0FFH, 080H, 078H, 00CH, 000H, 075H, 009H, 088H, 048H, 00CH
DB 08BH, 0F8H, 08BH, 000H, 0EBH, 0E5H, 038H, 048H, 00CH, 074H
DB 0A7H, 0C6H, 040H, 00CH, 000H, 080H, 07EH, 00CH, 000H, 075H
DB 0A3H, 0FFH, 046H, 01CH, 0EBH, 09EH, 08BH, 0FFH, 055H, 08BH
DB 0ECH, 051H, 053H, 056H, 057H, 08BH, 07DH, 008H, 08AH, 05FH
DB 00CH, 080H, 0FBH, 001H, 075H, 005H, 08BH, 077H, 008H, 0EBH
DB 003H, 08BH, 077H, 004H, 08AH, 04EH, 00CH, 03AH, 0CBH, 075H
DB 027H, 056H, 0E8H, 06FH, 000H, 000H, 000H, 032H, 0D2H, 088H
DB 056H, 00CH, 088H, 057H, 00CH, 033H, 0C0H, 0EBH, 00EH, 056H
DB 0E8H, 05DH, 000H, 000H, 000H, 0F6H, 0DBH, 033H, 0C0H, 088H
DB 05EH, 00CH, 040H, 05FH, 05EH, 05BH, 0C9H, 0C2H, 004H, 000H
DB 00FH, 0BEH, 0C3H, 00FH, 0BEH, 0C9H, 0F7H, 0D8H, 03BH, 0C8H
DB 089H, 045H, 0FCH, 075H, 0DCH, 080H, 0FBH, 001H, 075H, 005H
DB 08BH, 07EH, 004H, 0EBH, 003H, 08BH, 07EH, 008H, 057H, 0E8H
DB 02CH, 000H, 000H, 000H, 057H, 0E8H, 026H, 000H, 000H, 000H
DB 08BH, 04DH, 008H, 032H, 0D2H, 088H, 051H, 00CH, 088H, 056H
DB 00CH, 08AH, 047H, 00CH, 03AH, 0C3H, 075H, 007H, 0F6H, 0DBH
DB 088H, 059H, 00CH, 0EBH, 0A3H, 00FH, 0BEH, 0C0H, 03BH, 045H
DB 0FCH, 075H, 09BH, 088H, 05EH, 00CH, 0EBH, 096H, 08BH, 0FFH
DB 055H, 08BH, 0ECH, 08BH, 04DH, 008H, 08BH, 001H, 039H, 048H
DB 004H, 056H, 08BH, 030H, 075H, 011H, 08BH, 051H, 008H, 085H
DB 0D2H, 089H, 050H, 004H, 074H, 002H, 089H, 002H, 089H, 041H
DB 008H, 0EBH, 00FH, 08BH, 051H, 004H, 085H, 0D2H, 089H, 050H
DB 008H, 074H, 002H, 089H, 002H, 089H, 041H, 004H, 089H, 008H
DB 039H, 046H, 004H, 075H, 005H, 089H, 04EH, 004H, 0EBH, 003H
DB 089H, 04EH, 008H, 089H, 031H, 05EH, 05DH, 0C2H, 004H, 000H
DB 08BH, 0FFH, 055H, 08BH, 0ECH, 057H, 08BH, 07DH, 008H, 083H
DB 07FH, 018H, 000H, 075H, 012H, 033H, 0C0H, 0EBH, 009H, 033H
DB 0C0H, 040H, 08BH, 04DH, 010H, 089H, 031H, 05EH, 05FH, 05DH
DB 0C2H, 00CH, 000H, 056H, 08BH, 077H, 008H, 08DH, 046H, 010H
DB 050H, 0FFH, 075H, 00CH, 057H, 0FFH, 057H, 028H, 085H, 0C0H
DB 075H, 00FH, 08BH, 046H, 004H, 085H, 0C0H, 074H, 004H, 08BH
DB 0F0H, 0EBH, 0E6H, 06AH, 002H, 0EBH, 00EH, 083H, 0F8H, 001H
DB 075H, 0CBH, 08BH, 046H, 008H, 085H, 0C0H, 075H, 0ECH, 06AH
DB 003H, 058H, 0EBH, 0C2H, 08BH, 0FFH, 055H, 08BH, 0ECH, 08BH
DB 04DH, 00CH, 053H, 08BH, 059H, 004H, 085H, 0DBH, 056H, 057H
DB 074H, 01CH, 08BH, 041H, 008H, 085H, 0C0H, 074H, 015H, 080H
DB 079H, 00CH, 000H, 00FH, 08CH, 0D5H, 000H, 000H, 000H, 08BH
DB 0D8H, 08BH, 043H, 004H, 085H, 0C0H, 074H, 004H, 0EBH, 0F5H
DB 08BH, 0D9H, 08BH, 04BH, 004H, 08BH, 003H, 080H, 0CAH, 0FFH
DB 085H, 0C9H, 00FH, 085H, 0A5H, 000H, 000H, 000H, 039H, 058H
DB 004H, 08BH, 04BH, 008H, 075H, 005H, 089H, 048H, 004H, 0EBH
DB 005H, 089H, 048H, 008H, 0B2H, 001H, 08BH, 043H, 008H, 085H
DB 0C0H, 075H, 00AH, 0EBH, 00CH, 089H, 048H, 008H, 0B2H, 001H
DB 08BH, 043H, 004H, 08BH, 00BH, 089H, 008H, 08BH, 075H, 008H
DB 0C6H, 046H, 00CH, 000H, 08BH, 03BH, 08AH, 047H, 00CH, 03AH
DB 0C2H, 075H, 006H, 0C6H, 047H, 00CH, 000H, 0EBH, 010H, 084H
DB 0C0H, 074H, 01CH, 057H, 0E8H, 045H, 0FEH, 0FFH, 0FFH, 085H
DB 0C0H, 075H, 020H, 08BH, 03FH, 08BH, 007H, 080H, 0CAH, 0FFH
DB 039H, 078H, 008H, 075H, 002H, 0B2H, 001H, 08BH, 0F8H, 0EBH
DB 0D3H, 0F6H, 0DAH, 088H, 057H, 00CH, 080H, 07EH, 00CH, 000H
DB 074H, 003H, 0FFH, 04EH, 01CH, 08BH, 075H, 00CH, 03BH, 0F3H
DB 074H, 02CH, 08BH, 045H, 00CH, 08BH, 0FBH, 0A5H, 0A5H, 0A5H
DB 0A5H, 08BH, 008H, 039H, 041H, 004H, 08BH, 003H, 075H, 005H
DB 089H, 058H, 004H, 0EBH, 003H, 089H, 058H, 008H, 08BH, 043H
DB 004H, 085H, 0C0H, 074H, 002H, 089H, 018H, 08BH, 043H, 008H
DB 085H, 0C0H, 074H, 002H, 089H, 018H, 05FH, 05EH, 05BH, 05DH
DB 0C2H, 008H, 000H, 039H, 058H, 004H, 00FH, 085H, 06DH, 0FFH
DB 0FFH, 0FFH, 089H, 048H, 004H, 0E9H, 06AH, 0FFH, 0FFH, 0FFH
DB 08BH, 0D8H, 08BH, 043H, 008H, 085H, 0C0H, 00FH, 084H, 02DH
DB 0FFH, 0FFH, 0FFH, 0EBH, 0F1H, 08BH, 0FFH, 055H, 08BH, 0ECH
DB 08BH, 04DH, 008H, 08BH, 041H, 004H, 085H, 0C0H, 075H, 01CH
DB 0EBH, 002H, 08BH, 0C8H, 08BH, 001H, 039H, 048H, 004H, 074H
DB 0F7H, 039H, 048H, 008H, 075H, 004H, 039H, 000H, 075H, 002H
DB 033H, 0C0H, 05DH, 0C2H, 004H, 000H, 08BH, 0C1H, 08BH, 048H
DB 008H, 085H, 0C9H, 074H, 0F3H, 0EBH, 0F5H, 08BH, 0FFH, 055H
DB 08BH, 0ECH, 056H, 08BH, 075H, 010H, 056H, 0FFH, 075H, 00CH
DB 0FFH, 075H, 008H, 0E8H, 05EH, 0FEH, 0FFH, 0FFH, 083H, 0F8H
DB 001H, 08BH, 04DH, 014H, 089H, 001H, 074H, 004H, 033H, 0C0H
DB 0EBH, 005H, 08BH, 006H, 083H, 0C0H, 010H, 05EH, 05DH, 0C2H
DB 010H, 000H, 08BH, 0FFH, 055H, 08BH, 0ECH, 08BH, 04DH, 008H
DB 08BH, 041H, 008H, 085H, 0C0H, 075H, 01EH, 08BH, 001H, 039H
DB 048H, 008H, 074H, 013H, 08BH, 0D0H, 08BH, 042H, 004H, 02BH
DB 0C1H, 0F7H, 0D8H, 01BH, 0C0H, 0F7H, 0D0H, 023H, 0C2H, 05DH
DB 0C2H, 004H, 000H, 08BH, 0C8H, 0EBH, 0E2H, 08BH, 048H, 004H
DB 085H, 0C9H, 074H, 0F1H, 08BH, 0C1H, 0EBH, 0F5H