RPL_MASL         equ 11B
KGDT64_R3_CMCODE equ 00020H
KGDT64_R3_DATA   equ 00028H
KGDT64_R3_CODE   equ 00030H
KGDT64_R3_CMTEB  equ 00050H ; FS

FALSE            equ 0
TRUE             equ 1
NT_TIB STRUCT
    ExceptionList        DWORD ?
    StackBase            DWORD ?
    StackLimit           DWORD ?
    SubSystemTib         DWORD ?
    FiberData            DWORD ?
    ArbitraryUserPointer DWORD ?
    Self                 DWORD ?
NT_TIB    ENDS

CLIENT_ID STRUCT
    UniqueProcess DWORD ?
    UniqueThread  DWORD ?
CLIENT_ID ENDS

; Константы
D87_IP equ 12
D87_CS equ 16
D87_DP equ 20
D87_DS equ 24

; +
; OUT:
;	@fnstenv
;
Mm87GetIp proc
Local     State[108]:BYTE
Local     Envir[28]:BYTE
Local     Teb:DWORD

    mov    ax, ss
    fnsave State
    mov    ss, ax
    
    mov eax, fs:[30h] ; Get pointer to TEB
    
    push   eax
    push   fs
    pop    ds
    assume ds:nothing
    fild   dword ptr [eax+TEB.NtTib.Self] ; Load Self from TEB
    assume ds:error
    pop    eax
    
    fnstenv Envir
    fist    Teb
    frstor  State
    
    mov eax, dword ptr Envir[D87_DP]
    cmp eax, PAGE_SIZE
    jb  @F
    mov eax, fs:[eax]
@@:
    add eax, dword ptr Envir[D87_IP]
    sub eax, Teb
    ret
Mm87GetIp endp

; +
; o At NT-call mb ESP ~ [DeallocationStack % StackBase]
;
Stk86Crc  proc C
	push ebx
	%TLSP Ebx
	.if  Ebx
		bt  [ebx].Flags, TF_SCRC
		.if Carry?
			xchg [ebx].Stack, esp
			pushfd
			pushad

			mov eax, [ebx].Stack
			lea eax, [eax][-OPT_SCRC_SIZE]
			invoke Crc32, CRC32_BASE, Eax, OPT_SCRC_SIZE
		
			xor  [ebx].Crc,   eax
			popad
			popfd
			xchg [ebx].Stack, esp
		.endif
	.endif
	pop ebx
	ret
Stk86Crc endp

%ISWOW macro
	mov ecx, KGDT64_R3_CODE
	lar ecx, ecx
	bt  ecx, 21             ; L
endm

%TST macro
	mov fs:[SST.Stack][DSST], esp
	mov fs:[SST.Frame][DSST], ebp
endm

%TRT macro
	mov esp, fs:[SST.Stack][DSST]
	mov ebp, fs:[SST.Frame][DSST]
endm

MMKEY equ TRUE
TSKEY equ FALSE

; +
; o Called via CALL.
;
; ARGs	ESP[4]
;
; OUT:
;	ECX		@SYSCALL[2](wow64cpu!CpupSyscallStub -> SYSCALL/RET)
;
comment '
 At init phase use ZW-stub in compat mode.

 ZwYieldExecution:
	mov eax, X
 Gate:
	call fs:[C0] ; X86SwitchTo64BitMode: JMP FAR 33:CpupReturnFromSimulatedCode
	retn
	
 (W10)
 ZwYieldExecution:
	mov eax, ID
 Gate:
	mov  edx, offset Wow64SystemServiceCall
	call edx
	retn

Wow64SystemServiceCall:
	jmp [Wow64Transition]

 (WOW64CPU)

KiFastSystemCall2:
	push 33
	push eax
	Call $+5
	pop  eax
	add  eax,   12
	xchg [esp], eax
	jmp  far [esp]
L:
	add rsp, 8
	jmp CpupReturnFromSimulatedCode

KiFastSystemCall:
	jmp far 33:L
L:
	jmp [r15 + N] ; TurboThunkDispatch[N]: CpupReturnFromSimulatedCode

 W(6.1.7601)
 TurboDispatchJumpAddressStart:
	jmp [r15][rcx*8]

 ZwYieldExecution:
	mov eax, ID
	mov ecx, 1
 Gate:
	lea edx, [esp][4]
 	call fs:[C0]
	add esp, 4
 	retn
  	'
%WGATE macro
	%ENVP Edx
 	bt [edx].Flags, GF_NTEXT
	.if Carry?
		if OPT_TURBO_OFF eq FALSE
			mov ecx, eax
			shr ecx, 16
		else
			xor ecx, ecx
		endif
		movzx eax, ax
		.if   [Edx].Wow.Ps.Ssel != (KGDT64_R3_CODE or RPL_MASK)
			; CALL X86SwitchTo64BitMode/Wow64SystemServiceCall -> RET
			jmp [Edx].Wow.Ps.Sptr
		.endif
		Call   @f
		sub    esp, 8
		invoke Stk86Crc
		add    esp, 12
		retn
	@@:
		push   KGDT64_R3_CODE or RPL_MASK
		push   [edx].Wow.Ps.Sptr
		lea    edx, [esp][12]
		invoke Stk86Crc
		retf
	.endif

	if OPT_TURBO_OFF eq TRUE
		movzx eax, ax
	endif
	.if [Edx].Wow.Ps.Ssel != (KGDT64_R3_CODE or RPL_MASK)
		jmp [Edx].Wow.Ps.Sptr
	.endif
	Call   @f
	push   eax
	invoke Stk86Crc
	pop    eax
	retn
@@:
	invoke Stk86Crc
	jmp    fword ptr [Edx].Wow.Ps ; CpupReturnFromSimulatedCode
endm

comment '
 KiSystemCallExit2:
	EIP -> EDX
	ESP -> ECX
	'

%IGATE macro	; ARGs: EDX
	Int 2EH

; Fast kill without user-fault and caller-ip.

if OPT_SEXIT_KILL eq TRUE
	mov esp, ecx
	lea edx, [edx][7]
	jmp Edx
endif
endm

%CALL64 macro P
	push KGDT64_R3_CODE or RPL_MASK
	push P
	Call far ptr [Esp]
	lea  esp, [esp][8]
endm

%RETFN macro
	retf
endm

; +
; Call of service.
;
%NTCALL macro
Local NtpCall
	%ISWOW
	jnc Ntp86
	%WGATE
Ntp86:
	lea    edx, [esp][4]
	invoke Stk86Crc
	%IGATE
	invoke Stk86Crc
	ifdef  OPT_SEXIT_SUB
		sub ecx, esp ; TF -> ZF
	endif
	retn
endm

; +
; Call of service via CRC(ID).
;
; EAX:
;	CRC
;
%NTCALLCRC macro
NtGateCrc:
	invoke NtCrcToId, Eax
NtGateSid:
	%NTCALL
endm

%PCALL macro Id, Args
	mov  eax, Id
	Call NtGateCrc
	if   Args
		add esp, Args*4
	endif
endm

%RCALL macro Args
	Call NtGateSid
	if   Args
		add esp, Args*4
	endif
endm

; +
;
%TURBOSET macro
	%ENVP Ecx
	mov ecx,                [ecx].Wow.Turbo.Thunk
	mov DWORD PTR[ecx][0],  eax
	and DWORD PTR [ecx][4], 0
endm

; +
; TURBOSET(P(EAX))
;
%TURBOCALL macro Args
	%ENVP Ecx
	movzx eax, ax
	or    eax, [ecx].Wow.Turbo.Id
	Call  NtGateSid
	if    Args
		add esp, Args*4
	endif
endm

; +
; CB-enter and return.
;
; * restore SEH, mb use as key!
;
; EBX:
;	Return Key, shadowed by kernel.
;
; ESI: f(K) -> EIP
;	0	K + TLS.Key
;	1	K + NtCR.[V]
;
; o At return(%RTR) read NtCR.V to EAX.
;
GtCall proc C
	push ebp
	push fs:[TEB.NtTib.ExceptionList]
	push esp
	
; NtUserEnumDisplayMonitors(
;     IN HDC             hdc,
;     IN LPCRECT         lprcClip,
;     IN MONITORENUMPROC lpfnEnum,
;     IN LPARAM          dwData
;	)

	Call @f
	
; (CALLBACK* MONITORENUMPROC)(HMONITOR, HDC, LPRECT, LPARAM)

	mov  esp, DWORD PTR[esp][4*4]
	pop  fs:[TEB.NtTib.ExceptionList]
	pop  ebp
	retn                            ; Return to caller.
@@:
	push 0
	push 0
	%ENVR Eax, Gid
	Call @f
	int  3
@@:
	%ISWOW
	.if !Carry?
		lea edx, [esp][4]
		%IGATE
	.else
		%ENVP Edx
	 	bt ENV.Flags[edx], GF_NTEXT
		.if Carry?
			mov   ecx, eax
			shr   ecx, 16
			movzx eax, ax
			Call  @f
			jmp   GtpRet
		@@:
			push KGDT64_R3_CODE or RPL_MASK
			push ENV.Wow.Ps.Sptr[edx]
			lea  edx, [esp][12]
			retf
		@@:
			jmp fword ptr ENV.Wow.Ps[Edx] ; CpupReturnFromSimulatedCode
		.else
			Call @b
		.endif
	.endif
GtpRet:

; Zero if #PG else D[Fetch].

	.if Esi
		add ebx, eax
	.else
		add ebx, fs:[DKEY]
	.endif
	%TRT		; Restore stack.
	jmp Ebx
GtCall endp

%LKEY macro K
	mov ebx, K
endm

%TKEY macro K
	mov fs:[DKEY], K
endm

%CBC macro F	; F: L/T
	mov  esi, F
	Call GtCall
endm

comment '
BOOL    xxxClientMonitorEnumProc(
    HMONITOR        hMonitor,
    HDC             hdcMonitor,
    LPRECT          lprc,
    LPARAM          dwData,
    MONITORENUMPROC xpfnProc)
{
    SETUP(CLIENTMONITORENUMPROC)

    BEGINSEND(CLIENTMONITORENUMPROCMSG)

        MSGDATA()->hMonitor   = hMonitor   ;
        MSGDATA()->hdcMonitor = hdcMonitor ;
        MSGDATA()->rc         = *lprc      ;
        MSGDATA()->dwData     = dwData     ;
        MSGDATA()->xpfnProc   = xpfnProc   ;

        MAKECALL(CLIENTMONITORENUMPROC);
        CHECKRETURN();

    TRACECALLBACK("SxxxClientMonitorEnumProc");
    ENDSEND(BOOL,FALSE);
    
		~~~
		
#define CHECKRETURN()
    if (!NT_SUCCESS(Status) ||
            cbCBStatus != sizeof(*pcbs)) {
        goto errorexit ;
    }
    try {
        retval = ProbeAndReadStructure(&pcbs->retval, ULONG_PTR) ;
    } except (W32ExceptionHandler(FALSE, RIP_ERROR)) {
        MSGERROR();
    }
    
		~~~

#define ENDSEND(type, error)
        return (type)retval ;
        goto   errorexit    ;
    }
errorexit:
   return (type)error
   
		~~~
		
 * Callback return status
 */
typedef struct _CALLBACKSTATUS {
    KERNEL_ULONG_PTR retval   ;
    DWORD            cbOutput ;
    KERNEL_PVOID     pOutput  ;
} CALLBACKSTATUS, *PCALLBACKSTATUS ;
		
		~~~
		
NTSTATUS NtCallbackReturn (
	IN PVOID OutputBuffer OPTIONAL,
	IN ULONG OutputLength,
	IN NTSTATUS Status
	)
		~~~
Result:	
	NtCR.OutputLength --> cbCBStatus --> mb sizeof(CALLBACKSTATUS)
	NtCR.OutputBuffer --> pcbs --> &pcbs->retval: [OutputBuffer][0] -R-> EAX
	
	NtCR(V, sizeof(CALLBACKSTATUS)) --> EAX = [V]
	
	o For WOW: OutputBuffer mb aligned to 8(else #C000041D).
'

NtCrcToId proto Crc:ULONG

; +
; Return from CB to caller(restore RGP).
;
; EBX: @Fetch(NtCR.V)
;
	assume fs:nothing
RtCall proc C
	%TST		; Save stack.
	%ISWOW
	.if !Carry?
		xor eax, eax
		%ENVR Edx, Gsz
		mov ecx, ebx
		Int 2BH      ; KiCallbackReturn(Buffer: ECX, Length: EDX, Status: Eax)
		int 3
	.endif
	%ENVP Eax
	mov  ecx, ENV.Gsz[eax]
	mov  eax, ENV.Rid[eax]
	push STATUS_SUCCESS
	push ecx               ; ENV.Gsz: sizeof(CALLBACKSTATUS)
	push ebx               ; V
	Call NtGateSid
	int  3
RtCall endp

%CBR macro Fetch
	mov ebx, Fetch
	jmp RtCall
endm

; +
;
; Query size of CALLBACKSTATUS.
;	
RtSizeCallback proc HMONITOR0, HDC0, LPRECT0, S1ze:ULONG
	;%DBG "RTSIZECB 0x%X", S1ze
	mov  edx, S1ze
	lea  ecx, S1ze
	push STATUS_SUCCESS
	push S1ze
	push ecx
	%ENVR Eax, Rid
	Call NtGateSid
	int  3
RtSizeCallback endp

; +
;
RtGetSize      proc uses ebx
	xor ebx, ebx
	.repeat
		push ebx
		push offset RtSizeCallback
		push 0
		push 0
		%ENVP Eax
		mov  eax, ENV.Gid[Eax]
		Call NtGateSid
		add  esp, 4*4
		add  ebx, 4
	.until Eax || (Ebx >= 64)
	ret
RtGetSize endp

