d MACRO
    db 0CCh
ENDM

EOL  equ NULL
CRLF equ <13, 10, EOL>

DbgPrint proto C

%DBG macro Msg$, ArgList:VARARG
Local    S$
    if OPT_DEBUG eq TRUE
        pushfd
        pushad
        Args = 1
        For  Arg, <ArgList>
            Args = Args + 1
            push Arg
        Endm
    .data
        S$ CHAR Msg$, CRLF
    .code
        push offset S$
		;Call DbgPrint
        Call LgPrint
        add  esp, Args * 4
        popad
        popfd
    endif
endm

RANGE struct
    Base  PVOID ?
    Limit PVOID ?
RANGE         ends
PRANGE        typedef ptr RANGE

BOOL          typedef DWORD

LARGE_INTEGER STRUCT
    LowPart  DWORD ?
    HighPart DWORD ?
LARGE_INTEGER ENDS

TIMING        STRUCT
    File    LARGE_INTEGER <>
    Object  LARGE_INTEGER <>
    Timer   LARGE_INTEGER <>
    NtTicks LARGE_INTEGER <>
    RtTicks LARGE_INTEGER <>
    Current LARGE_INTEGER <>
TIMING ENDS

PCS    struct ; JMP FAR P32:S16
    Sptr PVOID ?
    Ssel ULONG ?
PCS ends

GF_NTEXT equ 0

TURBO struct
    Id       ULONG ? ; << 16
    Thunk    PVOID ? ; @V:THUNK64
    Return   PVOID ?
    Service  PVOID ? ; @TurboDispatchJumpAddressEnd
    Dispatch PVOID ? ; @TurboThunkDispatch
TURBO  ends
PTURBO typedef ptr TURBO

WOW    struct
    Ps    PCS <>
    Turbo TURBO <>
WOW ends

API struct
    pZwAllocateVirtualMemory PVOID ?
    pZwFreeVirtualMemory     PVOID ?
    pZwYieldExecution        PVOID ?
    Eol                      ULONG ?
API                      ends

MEMORY_BASIC_INFORMATION struct
    BaseAddress        PVOID ?
    AllocationBase     PVOID ?
    AllocationProtect  DWORD ?
    _Type              DWORD ?
    RegionSize         DWORD ?
    State              DWORD ?
    Protect            DWORD ?
    InheritDisposition DWORD ?
MEMORY_BASIC_INFORMATION ends

NTMM                     STRUCT
    Alloc DWORD ?
    Free  DWORD ?
NTMM ENDS

TENV struct ; Temp ENV(use at init).
    Flags    DWORD ?
    Key      DWORD ?
    Wow      WOW <>          ; CM gate CS:PTR; FIRST FIELD!
    NtBase   DWORD ?
    NtMemory NTMM <>
    Api      API <>
    Yield    DWORD ?         ; NtYieldExecution
    Section  PVOID ?
    Smap     DWORD ?
    Rmap     DWORD ?
    Trace    BYTE 32 DUP (?)
    Time     TIMING <>
TENV ends

ENV  struct ; Global envir.
    TENV    <>
    TsBase  PVOID ?
    TsMap   DWORD 8 DUP (?)
    Gid     ULONG ?          ; NtUserEnumDisplayMonitors
    Rid     ULONG ?          ; NtCallbackReturn
    Gsz     ULONG ?          ; KICB args
    NtTree  RTL_AVL_TABLE <>
    NtStore RANGE <>
    Timer   PVOID ?
ENV  ends
PENV typedef ptr ENV

SST  struct          ; Stack state.
    Stack PVOID ?
    Frame PVOID ?
SST  ends
PSST typedef ptr SST

TF_SCRC equ 0 ; STKCRC()

TLS struct ; Local storage in TEB.
    Flags DWORD ?
    Key   DWORD ?
    Crc   DWORD ?
    Stack PVOID ?
    Tid   ULONG ?
    TsI   ULONG ?                     ; TLS ID
    Store BYTE OPT_STACK_SIZE DUP (?)
TLS  ends
PTLS typedef ptr TLS

DTLS equ PAGE_SIZE - 4   ; TEB[DTLS]:PTLS
DENV equ PAGE_SIZE - 4   ; PEB[DENV]:PENV
DWOW equ 0C0H
DKEY equ PAGE_SIZE - 2*4
DSST equ PAGE_SIZE - 4*4

    assume fs:nothing
%TLSP macro R
    mov    eax, fs:[DTLS]
    mov    R,   DWORD PTR [eax]
    assume R:PTLS
endm

%TLSR macro R, V
    %TLSP R
    mov R, [R].V
endm

%ENVP macro R
	mov R,fs:[TEB.ProcessEnvironmentBlock]
	mov R,dword ptr [R][DENV]
	assume R:PENV
endm


%ENVR macro R, V    ; Read ENV.V
    %ENVP R
    mov R, [R].V
endm

%ENVS macro V
	mov eax,fs:[TEB.ProcessEnvironmentBlock]
	mov dword ptr [eax][DENV],V
endm

RGP struct ; PUSHAD frame.
    rEdi DWORD ?
    rEsi DWORD ?
    rEbp DWORD ?
    rEsp DWORD ?
    rEbx DWORD ?
    rEdx DWORD ?
    rEcx DWORD ?
    rEax DWORD ?
RGP          ends
PRGP         typedef ptr RGP

QUOTA_LIMITS STRUCT
    PagedPoolLimit        DWORD ?
    NonPagedPoolLimit     DWORD ?
    MinimumWorkingSetSize DWORD ?
    MaximumWorkingSetSize DWORD ?
    PagefileLimit         DWORD ?
    TimeLimit             LARGE_INTEGER <>
QUOTA_LIMITS              ENDS

PMEMORY_BASIC_INFORMATION TYPEDEF PTR MEMORY_BASIC_INFORMATION

PPVOID                    TYPEDEF PTR PVOID

; List Entry structure
LIST_ENTRY                STRUCT
    Flink DWORD ?
    Blink DWORD ?
LIST_ENTRY     ENDS

PLIST_ENTRY    TYPEDEF PTR LIST_ENTRY
DOUBLE_PTR TYPEDEF PTR

UNICODE_STRING STRUCT
    _Length              WORD     ?   ; Length of string in bytes
    MaximumLength       WORD     ?   ; Maximum length of string in bytes
    Buffer              DOUBLE_PTR ? ; Pointer to string buffer
UNICODE_STRING ENDS

PLDR_DATA_TABLE_ENTRY  TYPEDEF PTR LDR_DATA_TABLE_ENTRY

LDR_DATA_TABLE_ENTRY struct ; (sizeof=0X54, standard type)
    InLoadOrderModuleList           LIST_ENTRY     <>
    InMemoryOrderModuleList         LIST_ENTRY     <>
    InInitializationOrderModuleList LIST_ENTRY     <>
    DllBase                         DWORD          ?         ; offset (FFFFFFFF)
    EntryPoint                      DWORD          ?         ; offset (FFFFFFFF)
    SizeOfImage                     DWORD          ?
    FullDllName                     UNICODE_STRING <>
    BaseDllName                     UNICODE_STRING <>
    Flags                           DWORD          ?
    LoadCount                       WORD           ?
    TlsIndex                        WORD           ?
    CheckSum                        DWORD          ?
    EntryPointActivationContext     DWORD          ?    ; offset (FFFFFFFF)
    PatchInformation                DWORD          ?    ; offset (FFFFFFFF)
LDR_DATA_TABLE_ENTRY ends


; IMAGE_EXPORT_DIRECTORY structure
IMAGE_EXPORT_DIRECTORY STRUCT
    Characteristics       DWORD ?
    TimeDateStamp         DWORD ?
    MajorVersion          WORD ?
    MinorVersion          WORD ?
    Name                  DWORD ?
    Base                  DWORD ?
    NumberOfFunctions     DWORD ?
    NumberOfNames         DWORD ?
    AddressOfFunctions    DWORD ?
    AddressOfNames        DWORD ?
    AddressOfNameOrdinals DWORD ?
IMAGE_EXPORT_DIRECTORY   ENDS
PIMAGE_EXPORT_DIRECTORY  TYPEDEF PTR IMAGE_EXPORT_DIRECTORY

; Constants
PAGE_SIZE                EQU 4096
STATUS_SUCCESS           EQU 0
THREAD_QUERY_INFORMATION EQU 40h
SYMBOLIC_LINK_ALL_ACCESS EQU 000F0001h
TIMER_ALL_ACCESS         EQU 1F0003h
PAGE_READONLY            EQU 02h

; Определение структур
NT_TIB                   STRUCT
    ExceptionList        DWORD ?
    StackBase            DWORD ?
    StackLimit           DWORD ?
    SubSystemTib         DWORD ?
    FiberData            DWORD ?
    ArbitraryUserPointer DWORD ?
    Self                 DWORD ?
NT_TIB                    ENDS

FileStandardInformation   EQU 5

FILE_STANDARD_INFORMATION STRUCT
    AllocationSize DQ ?
    EndOfFile      DQ ?
    NumberOflinks  DWORD ?
    DeletePending  DB ?
    Directory      DB ?
FILE_STANDARD_INFORMATION  ENDS
PFILE_STANDARD_INFORMATION TYPEDEF PTR FILE_STANDARD_INFORMATION

OBJECT_ATTRIBUTES          STRUCT
    uLength                   DWORD ?
    hRootDirectory            DWORD ?
    uAttributes               DWORD ?
    pSecurityDescriptor       DWORD ?
    pSecurityQualityOfService DWORD ?
    pObjectName               DWORD ?
OBJECT_ATTRIBUTES ENDS


IO_STATUS_BLOCK   STRUCT
    Status      DWORD ?
    Information DWORD ?
IO_STATUS_BLOCK       ENDS

MAX_PATH              EQU 260
FILE_ALL_ACCESS       EQU 1FFFH
FILE_ATTRIBUTE_NORMAL EQU 80H
FILE_OVERWRITE_IF     EQU 5
FILE_RANDOM_ACCESS    EQU 40000000H
NtCurrentProcess      EQU 0
NULL                  EQU 0
ProcessImageFileName  EQU 7
CRC_NTDLL_U equ 26797E77H


; Определение CLIENT_ID, если оно еще не определено
CLIENT_ID STRUCT
    UniqueProcess DWORD ?
    UniqueThread  DWORD ?
CLIENT_ID ENDS

TEB STRUCT
    NtTib                   NT_TIB <>
    EnvironmentPointer      DWORD ?
    ClientId                CLIENT_ID <>
    ActiveRpcHandle         DWORD ?
    ThreadLocalStoragePointer DWORD ?
    ProcessEnvironmentBlock DWORD ?
    LastErrorValue          DWORD ?	
    CountOfOwnedCriticalSections DWORD ?
    CsrClientThread         DWORD ?
    Win32ThreadInfo         DWORD ?
    User32Reserved          DWORD 26 dup(?)
    UserReserved            DWORD 5 dup(?)
    WOW32Reserved           DWORD ?
    CurrentLocale           DWORD ?
    FpSoftwareStatusRegister DWORD ?
    SystemReserved1         DWORD 54 dup(?)
    ExceptionCode           DWORD ?
    ActivationContextStackPointer DWORD ?
    SpareBytes1             BYTE 24 dup(?)
    RealClientId            CLIENT_ID <>
    GdiCachedProcessHandle  DWORD ?
    GdiClientPID            DWORD ?
    GdiClientTID            DWORD ?
    GdiThreadLocalInfo      DWORD ?
    Win32ClientInfo         DWORD 62 dup(?)
    glDispatchTable         DWORD 233 dup(?)
    glReserved1             DWORD 29 dup(?)
    glReserved2             DWORD ?
    glSectionInfo           DWORD ?
    glSection               DWORD ?
    glTable                 DWORD ?
    glCurrentRC             DWORD ?
    glContext               DWORD ?
    LastStatusValue         DWORD ?
    StaticUnicodeString     UNICODE_STRING <>
    StaticUnicodeBuffer     WORD 261 dup(?)
    DeallocationStack       DWORD ?
    TlsSlots                DWORD 64 dup(?)
    TlsLinks                LIST_ENTRY <>
    Vdm                     DWORD ?
    ReservedForNtRpc        DWORD ?
    DbgSsReserved           DWORD 2 dup(?)
    HardErrorMode           DWORD ?
    Instrumentation         DWORD 9 dup(?)
    SubProcessTag           DWORD ?
    EtwLocalData            DWORD ?
    EtwTraceData            DWORD ?
    WinSockData             DWORD ?
    GdiBatchCount           DWORD ?
    CurrentIdealProcessor   DWORD ?
    GuaranteedStackBytes    DWORD ?
    ReservedForPerf         DWORD ?
    ReservedForOle          DWORD ?
    WaitingOnLoaderLock     DWORD ?
    SavedPriorityState      DWORD ?
    SoftPatchPtr1           DWORD ?
    ThreadPoolData          DWORD ?
    TlsExpansionSlots       DWORD ?
    DeallocationBStore      DWORD ?
    BStoreLimit             DWORD ?
    ImpersonationLocale     DWORD ?
    IsImpersonating         DWORD ?
    NlsCache                DWORD ?
    pShimData               DWORD ?
    HeapVirtualAffinity     DWORD ?
    CurrentTransactionHandle DWORD ?
    ActiveFrame             DWORD ?
    FlsData                 DWORD ?
    PreferredLanguages      DWORD ?
    UserPrefLanguages       DWORD ?
    MergedPrefLanguages     DWORD ?
    MuiImpersonation        DWORD ?
    CrossTebFlags           WORD ?
    SameTebFlags            WORD ?
    TxnScopeEnterCallback   DWORD ?
    TxnScopeExitCallback    DWORD ?
    TxnScopeContext         DWORD ?
    LockCount               DWORD ?
    SpareUlong0             DWORD ?
    ResourceRetValue        DWORD ?
TEB ENDS

; PEB structure (simplified)
PEB STRUCT
    Reserved1              BYTE 2 DUP (?)
    BeingDebugged          BYTE ?
    Reserved2              BYTE ?
    Reserved3              DWORD 2 DUP (?)
    Ldr                    DWORD ?
    ProcessParameters      DWORD ?
    Reserved4              DWORD 3 DUP (?)
    AtlThunkSListPtr       DWORD ?
    Reserved5              DWORD ?
    Reserved6              DWORD ?
    Reserved7              DWORD ?
    Reserved8              DWORD ?
    AtlThunkSListPtr32     DWORD ?
    Reserved9              DWORD 45 DUP (?)
    Reserved10             BYTE 96 DUP (?)
    PostProcessInitRoutine DWORD ?
    Reserved11             BYTE 128 DUP (?)
    Reserved12             DWORD ?
    SessionId              DWORD ?
    ImageBaseAddress       DWORD ?
	    KernelCallbackTable DWORD ?

    ; Add other fields as needed
PEB                   ENDS

IMAGE_BASE_RELOCATION STRUCT
    VirtualAddress DWORD ?
    SizeOfBlock    DWORD ?
IMAGE_BASE_RELOCATION           ENDS

PIMAGE_BASE_RELOCATION          TYPEDEF PTR IMAGE_BASE_RELOCATION


; Constants
PAGE_SIZE                       EQU 4096
STATUS_SUCCESS                  EQU 0
THREAD_QUERY_INFORMATION        EQU 40h
SYMBOLIC_LINK_ALL_ACCESS        EQU 000F0001h
TIMER_ALL_ACCESS                EQU 1F0003h
PAGE_READONLY                   EQU 02h
FileStandardInformation         EQU 5
FileBasicInformation            EQU 4
ObjectBasicInformation          EQU 0
NotificationTimer               EQU 0
TimerBasicInformation           EQU 0
MemoryMappedFilenameInformation EQU 16
MemoryBasicInformation          EQU 0
MemoryWorkingSetList            EQU 0
ProcessQuotaLimits              EQU 1
SEC_COMMIT                      EQU 8000000h
SECTION_ALL_ACCESS              EQU 0F000Fh
ViewShare                       EQU 1
MEM_IMAGE                       EQU 1000000h
STATUS_DLL_NOT_FOUND            EQU 80000135h
STATUS_ENTRYPOINT_NOT_FOUND     EQU 80000033h
STATUS_BAD_DLL_ENTRYPOINT       EQU 800000C1h
SystemTimeOfDayInformation      EQU 3

MEMORY_WORKING_SET_LIST         STRUCT
    NumberOfEntries DWORD ?
    WorkingSetInfo  DWORD ?
MEMORY_WORKING_SET_LIST ENDS

PAGE_READWRITE          EQU 04h
MEM_COMMIT              EQU 1000h
MEM_RELEASE             EQU 8000h
PAGE_EXECUTE_READWRITE  EQU 40h
PAGE_EXECUTE_READ       EQU 20h


; PEB_LDR_DATA structure
PEB_LDR_DATA            STRUCT
    Reserved1         BYTE 2 DUP (?)
    BeingDebugged     BYTE ?
    Reserved2         BYTE ?
    Reserved3         DWORD 2 DUP (?)
    Ldr               DWORD ?
    ProcessParameters DWORD ?
    Reserved4         DWORD 3 DUP (?)
    AtlThunkSListPtr  DWORD ?
    Reserved5         DWORD ?
	    InMemoryOrderModuleList LIST_ENTRY <>

    Reserved6              DWORD ?
    Reserved7              DWORD ?
    Reserved8              DWORD ?
    AtlThunkSListPtr32     DWORD ?
    Reserved9              DWORD 45 DUP (?)
    Reserved10             BYTE 96 DUP (?)
    PostProcessInitRoutine DWORD ?
    Reserved11             BYTE 128 DUP (?)
    Reserved12             DWORD ?
    SessionId              DWORD ?
    ImageBaseAddress       DWORD ?
PEB_LDR_DATA     ENDS

; IMAGE_DOS_HEADER structure
IMAGE_DOS_HEADER STRUCT
    e_magic    WORD ?
    e_cblp     WORD ?
    e_cp       WORD ?
    e_crlc     WORD ?
    e_cparhdr  WORD ?
    e_minalloc WORD ?
    e_maxalloc WORD ?
    e_ss       WORD ?
    e_sp       WORD ?
    e_csum     WORD ?
    e_ip       WORD ?
    e_cs       WORD ?
    e_lfarlc   WORD ?
    e_ovno     WORD ?
    e_res      WORD 4 DUP (?)
    e_oemid    WORD ?
    e_oeminfo  WORD ?
    e_res2     WORD 10 DUP (?)
    e_lfanew   DWORD ?
IMAGE_DOS_HEADER  ENDS

IMAGE_FILE_HEADER STRUCT
    Machine              WORD ?
    NumberOfSections     WORD ?
    TimeDateStamp        DWORD ?
    PointerToSymbolTable DWORD ?
    NumberOfSymbols      DWORD ?
    SizeOfOptionalHeader WORD ?
    Characteristics      WORD ?
IMAGE_FILE_HEADER    ENDS

IMAGE_DATA_DIRECTORY STRUCT
    VirtualAddress DWORD ?
    _Size          DWORD ?
IMAGE_DATA_DIRECTORY  ENDS

IMAGE_OPTIONAL_HEADER STRUCT
    Magic                       WORD ?
    MajorLinkerVersion          BYTE ?
    MinorLinkerVersion          BYTE ?
    SizeOfCode                  DWORD ?
    SizeOfInitializedData       DWORD ?
    SizeOfUninitializedData     DWORD ?
    AddressOfEntryPoint         DWORD ?
    BaseOfCode                  DWORD ?
    BaseOfData                  DWORD ?
    ImageBase                   DWORD ?
    SectionAlignment            DWORD ?
    FileAlignment               DWORD ?
    MajorOperatingSystemVersion WORD ?
    MinorOperatingSystemVersion WORD ?
    MajorImageVersion           WORD ?
    MinorImageVersion           WORD ?
    MajorSubsystemVersion       WORD ?
    MinorSubsystemVersion       WORD ?
    Win32VersionValue           DWORD ?
    SizeOfImage                 DWORD ?
    SizeOfHeaders               DWORD ?
    CheckSum                    DWORD ?
    Subsystem                   WORD ?
    DllCharacteristics          WORD ?
    SizeOfStackReserve          DWORD ?
    SizeOfStackCommit           DWORD ?
    SizeOfHeapReserve           DWORD ?
    SizeOfHeapCommit            DWORD ?
    LoaderFlags                 DWORD ?
    NumberOfRvaAndSizes         DWORD ?
    DataDirectory               IMAGE_DATA_DIRECTORY 16 DUP (<>)
IMAGE_OPTIONAL_HEADER ENDS

; IMAGE_NT_HEADERS structure
IMAGE_NT_HEADERS      STRUCT
    Signature      DWORD ?
    FileHeader     IMAGE_FILE_HEADER <>
    OptionalHeader IMAGE_OPTIONAL_HEADER <>
IMAGE_NT_HEADERS     ENDS

; Constants
OBJ_CASE_INSENSITIVE EQU 00000040h

KERNEL_USER_TIMES    STRUCT
    CreateTime QWORD ?
    ExitTime   QWORD ?
    KernelTime QWORD ?
    UserTime   QWORD ?
KERNEL_USER_TIMES               ENDS

IMAGE_DIRECTORY_ENTRY_BASERELOC EQU 5
ThreadHideFromDebugger          EQU 11h
NtCurrentThread                 EQU 0
NtCurrentProcess                EQU 0
ProcessDebugObjectHandle        EQU 1Eh
ProcessDebugFlags               EQU 1FBh

RPL_MASK equ 03h  ; Request Privilege Level mask (3 = User mode)