NTID struct
Hash ULONG ?
Id   ULONG ?
if   OPT_NTNAME
	ZwName PSTR ?
endif
NTID  ends
PNTID typedef ptr NTID

SERVICE_NUMBER_MASK equ 00FFFH

;
; +
;
NtGetSid proc pZw:PVOID
	bts ecx, 31               ; Turbo ID << 16
	mov eax, pZw              ; @Gate
	xor edx, edx              ; NT ID
	.if BYTE PTR[Eax] == 0B8H ; mov eax,Id
		mov edx, DWORD PTR[eax][1] ; Id
		add eax, 5
		.if BYTE PTR [Eax] == 0B9H ; mov ecx,N
			mov ecx, DWORD PTR[eax][1]
			shl ecx, 16
			add eax, 5
			or  edx, ecx
		.elseif WORD PTR[Eax] == 0C933H ; xor ecx,ecx
			add eax, 2
			xor ecx, ecx
		.endif
		test eax, eax
		btr  ecx, 31
	.else
		xor eax, eax
	.endif
	ret
NtGetSid endp

; +
;
NtTreeCallback proc Tree:PRTL_AVL_TABLE, Entry:PVOID, $Name:PSTR
Local    Nt:NTID
    mov ecx, Entry
    mov edx, $Name
    .if WORD PTR [Edx] == 'wZ'
        invoke NtGetSid, Entry
        .if    !Zero?
            mov Nt.Id,   edx
            invoke Crc32S, CRC32_BASE, $Name
            mov Nt.Hash, eax
            if  OPT_NTNAME
                mov ecx,       $Name
                mov Nt.ZwName, ecx
            endif
            
            lea  eax, Nt
            push 0
            push sizeof(NTID)
            push eax
            push DWORD PTR [Tree] ; Разыменовываем указатель на Tree
            %AVL AVL_InsertElementGenericTable
        .endif
    .endif
    xor ebx, ebx ; Устанавливаем флаг ZF
    ret
NtTreeCallback endp

NT_AVL_COMPARE_ROUTINE proc pTable:PRTL_AVL_TABLE, pHash:PVOID, Nt:PNTID
	mov ecx, Nt
	mov eax, pHash
	mov ecx, NTID.Hash[ecx]
	mov eax, DWORD PTR[eax]
	.if Eax == Ecx
		mov eax, GenericEqual
	.elseif Eax < Ecx
		mov eax, GenericLessThan
	.else
		mov eax, GenericGreaterThan
	.endif
	ret
NT_AVL_COMPARE_ROUTINE  endp

NT_AVL_ALLOCATE_ROUTINE proc pTable:PRTL_AVL_TABLE, S1ze:ULONG
	%ENVP Eax
	invoke MmAlloc, addr ENV.NtStore[Eax], 32*1000H, S1ze
	ret
NT_AVL_ALLOCATE_ROUTINE endp

NT_AVL_FREE_ROUTINE     proc pTable:PRTL_AVL_TABLE, pBuffer:PVOID
	mov eax, TRUE
	ret
NT_AVL_FREE_ROUTINE endp

PeEnumExport proto Image:PVOID, Callback:PVOID, Argument:PVOID

; +
;
NtTree              proc uses ebx esi NtBase:PVOID, Tree:PRTL_AVL_TABLE
    LOCAL callback_args:DWORD

    push NULL
    push offset NT_AVL_FREE_ROUTINE
    push offset NT_AVL_ALLOCATE_ROUTINE
    push offset NT_AVL_COMPARE_ROUTINE
    push Tree
    %AVL AVL_InitializeGenericTable

    ; Сохраняем Tree в callback_args
    mov eax,           Tree
    mov callback_args, eax

    ; Создаем структуру для callback
    push callback_args
    push offset NtTreeCallback
    push NtBase
    call PeEnumExport
    add  esp, 12               ; Очищаем стек после вызова

    push Tree
    %AVL AVL_NumberGenericTableElements
    .if  eax < 100h
        xor eax, eax
    .endif
    ret
NtTree    endp
; +
; o ID masked for WOW.
;
NtCrcToId proc Hash:ULONG
	lea  ecx, Hash
	%ENVP Eax
	add  eax, ENV.NtTree
	push ecx
	push eax
	%AVL AVL_LookupElementGenericTable
	.if  Eax
		mov eax, NTID.Id[eax]
	.endif
	ret
NtCrcToId           endp

PeQueryRoutinesFast proto Base:PVOID, pList:PVOID

; +
;
NtGateInit          proc uses ebx Env:PENV
	mov    ebx,                                Env
	assume ebx:PENV
	mov    [ebx].Api.pZwAllocateVirtualMemory, CRC_NT_ALLOCATE_VIRTUAL_MEMORY
	mov    [ebx].Api.pZwFreeVirtualMemory,     CRC_NT_FREE_VIRTUAL_MEMORY
	mov    [ebx].Api.pZwYieldExecution,        CRC_NT_YIELD_EXECUTION
;	and [ebx].Api.Eol,0
	invoke PeQueryRoutinesFast, [Ebx].NtBase, addr [Ebx].Api
	.if Zero?
		invoke NtGetSid,             [Ebx].Api.pZwAllocateVirtualMemory
		mov    [ebx].NtMemory.Alloc, edx
		.if    !Zero?
			invoke NtGetSid,            [Ebx].Api.pZwFreeVirtualMemory
			mov    [ebx].NtMemory.Free, edx
			.if    !Zero?
				invoke NtGetSid, [Ebx].Api.pZwYieldExecution
				.if    !Zero?
					mov [ebx].Wow.Ps.Sptr, eax
					%DBG "NtGateInit.PTR 0x%p", Eax
;					mov [ebx].Wow.Ps.Ssel,0
					mov [ebx].Yield, edx
					.if !Carry?
						bts [ebx].Flags, GF_NTEXT
						%DBG "NtGateInit.NTX"
					.endif
					jmp Exit
				.endif
			.endif
		.endif
	.endif
	xor eax, eax
Exit:
	ret
NtGateInit endp

PeMapView proto pImage:PVOID, Access:ULONG, ViewBase:PPVOID

; +(-W10 ?)
;
NtReTree   proc uses ebx
Local      Base:PVOID
Local      Mem:MEMORY_BASIC_INFORMATION
	%ENVP Ebx
	assume ebx:PENV
	and    Base, 0
	invoke PeMapView, [Ebx].NtBase, PAGE_READONLY, addr Base
	%DBG "NtReTree.PeMapView 0x%X", Eax
	test   eax,  eax
	jl     Error

	lea  eax, Mem
	push NULL
	push sizeof(MEMORY_BASIC_INFORMATION)
	push eax
	push MemoryBasicInformation
	push [ebx].NtStore.Base
	push NtCurrentProcess
	%PCALL CRC_NT_QUERY_VIRTUAL_MEMORY, 6
	%DBG "NtReTree.NTQUERY 0x%X", Eax
	.if  !Eax
		invoke NtFree,              Mem.AllocationBase
		%DBG "NtReTree.NtFree 0x%X", Eax
		and    [ebx].NtStore.Base,  0
		and    [ebx].NtStore.Limit, 0
		invoke NtTree, Base, addr [Ebx].NtTree
		%DBG "NtReTree.NtTree 0x%X", Eax
		push   eax
		push   Base
		push   NtCurrentProcess
		%PCALL CRC_NT_UNMAP_VIEW_OF_SECTION, 2
		%DBG "NtReTree.NTUNMAP 0x%X", Eax
		pop    eax
		jmp    Exit
	.endif
Error:
	xor eax, eax
Exit:
	ret
NtReTree endp

CRC_USER32                equ 02489AABH

CRC_ENUM_DISPLAY_MONITORS equ 94876EF1H

; +
;
NtGetUserId proc uses ebx
Local       Base:PVOID
Local       pEntry[2]:PVOID
	mov    ebx,   fs:[TEB.ProcessEnvironmentBlock]
	and    Base,  0
	mov    ebx,   PEB.KernelCallbackTable[ebx]
	%DBG "NtGetUserId.KCT 0x%p", Ebx
	invoke MmCrc, Ebx
	.if    Eax == CRC_USER32
		invoke PeMapView, Ebx, PAGE_READONLY, addr Base
		%DBG "NtGetUserId.PeMapView 0x%X", Eax
		test eax,       eax
		jl   Error
		and  pEntry[4], 0
		mov  pEntry[0], CRC_ENUM_DISPLAY_MONITORS
		invoke PeQueryRoutinesFast, Base, addr pEntry
		.if  Zero?
			.if BYTE PTR[Eax] == 0B8H
				mov eax, DWORD PTR[eax][1] ; ID > 0x1000
				%DBG "NtGetUserId.ID 0x%X", Eax
			.else
				xor eax, eax
			.endif
		.endif
		mov  ebx, eax
		push Base
		push NtCurrentProcess
		%PCALL CRC_NT_UNMAP_VIEW_OF_SECTION, 2
		mov  eax, ebx
		jmp  Exit
	.endif
Error:
	xor eax, eax
Exit:
	ret
NtGetUserId endp
