
; +
;
; o Async access to LDR!
;
assume fs:nothing

PeGetNativeBase proc uses ebx esi edi
    mov ebx, fs:[TEB.ProcessEnvironmentBlock]
    mov ebx, PEB.Ldr[ebx]
    lea ebx, PEB_LDR_DATA.InMemoryOrderModuleList[ebx]
    assume ebx:PLIST_ENTRY

    mov esi, [ebx].Flink
    assume esi:PLIST_ENTRY

    .while ebx != esi
        lea edi, [esi]-LDR_DATA_TABLE_ENTRY.InMemoryOrderModuleList
        assume edi:PLDR_DATA_TABLE_ENTRY
        cmp WORD PTR [edi].BaseDllName._Length, 0
        je NextModule
        movzx eax, WORD PTR [edi].BaseDllName._Length
        invoke Crc32, CRC32_BASE, [edi].BaseDllName.Buffer, eax
        .if eax == CRC_NTDLL_U
            mov eax, [edi].DllBase
            mov edx, edi
            jmp Exit
        .endif
NextModule:
        mov esi, [esi].Flink
    .endw
    xor eax, eax
Exit:
    ret
PeGetNativeBase endp

; +
; ZF if success.
;
PeEnumExport proc uses ebx esi edi Image:PVOID, Callback:PVOID, Argument:PVOID
Local           Export:PIMAGE_EXPORT_DIRECTORY
    mov    ebx,    Image
    mov    eax,    ebx
    add    eax,    IMAGE_DOS_HEADER.e_lfanew[eax]
    mov    eax,    IMAGE_NT_HEADERS.OptionalHeader.DataDirectory.VirtualAddress[eax]
    add    eax,    ebx
    assume eax:PIMAGE_EXPORT_DIRECTORY
    mov    Export, eax

    mov edi, [eax].NumberOfNames
    mov esi, [eax].AddressOfNames
    xor eax, eax
    .if Esi && Edi
        add esi, ebx
    Walk:    
        mov  eax, DWORD PTR [esi + edi * 4]
        add  eax, ebx
        push eax
    
        mov    ecx, Export
        assume ecx:PIMAGE_EXPORT_DIRECTORY
        mov    eax, [ecx].AddressOfNameOrdinals
        add    eax, ebx
        movzx  edx, WORD PTR [2 * edi][eax]
        mov    eax, [ecx].AddressOfFunctions
        add    eax, ebx
        mov    eax, DWORD PTR [4 * edx][eax]
        add    eax, ebx
        
        push eax
        push Argument
        Call Callback
        jz   Exit
        dec  edi
        jnz  Walk
    .endif
    test ebx, ebx
Exit:
    ret
PeEnumExport endp

; +
;
PeIsApiCrc32 proc Hash:PVOID, Entry:PVOID, $Name:PSTR
    invoke Crc32S, CRC32_BASE, $Name
    cmp Hash, eax
    jne @F
    mov eax,  Entry
    ret
@@:
    xor eax, eax
    ret
PeIsApiCrc32     endp

; +
; ZF if success.
;
xPeQueryRoutines proc uses edi ImageBase:PVOID, pList:PVOID
    mov edi, pList
Walk:
    push [edi]                ; Push the current list item onto the stack
    invoke PeEnumExport, ImageBase, offset PeIsApiCrc32, esp
    pop  ecx                  ; Remove the item from the stack
    test eax,             eax
    jnz  NotFound
    mov  DWORD PTR [edi], eax ; Store the result
    add  edi,             4   ; Move to the next DWORD in the list
    cmp  DWORD PTR [edi], 0   ; Check for EOL
    jne  Walk
    xor  eax,             eax ; Set ZF to indicate success
    jmp  Done
NotFound:
    or eax, 1 ; Clear ZF to indicate failure
Done:
    ret
xPeQueryRoutines endp

APIS             struct
N                ULONG ?
pList            PVOID ?
Map              BYTE 256 DUP (?)
APIS             ends
PAPIS            typedef ptr APIS

; +
;
PeIsApiCrc32Fast proc uses ebx Api:PAPIS, Entry:PVOID, $Name:PSTR
	invoke Crc32S, CRC32_BASE, $Name
	mov    ebx, Api
	assume ebx:PAPIS
	xor    ecx, ecx
	mov    edx, [ebx].pList
	.repeat
		bt  DWORD PTR[ebx].Map, ecx
		.if !Carry?
			.if DWORD PTR[Edx] == Eax
				mov eax,                Entry
				bts DWORD PTR[ebx].Map, ecx
				mov DWORD PTR[edx],     eax
				dec [ebx].N
			.endif
		.endif
		inc ecx
		add edx, 4
	.until !DWORD PTR[Edx] ; EOL
	cmp    [ebx].N, 0
	ret
PeIsApiCrc32Fast    endp

; +
; ZF if success.
;
PeQueryRoutinesFast proc uses edi Image:PVOID, pList:PVOID
Local               Api:APIS
	.if !Image
		invoke PeGetNativeBase
		mov    Image, eax
	.endif
	mov edx,       pList
	xor eax,       eax
	mov Api.pList, edx
	mov ecx,       (sizeof(APIS) - APIS.Map)/4
	lea edi,       Api.Map
	rep stosd

	mov edi,   pList
	mov ecx,   esp
	repne scasd
	not ecx
	add ecx,   esp
	mov Api.N, ecx
	
	invoke PeEnumExport, Image, offset PeIsApiCrc32Fast, addr Api
	ret
PeQueryRoutinesFast endp

; +
;
PeMapView proc pImage:PVOID, Access:ULONG, ViewBase:PPVOID
Local               FileU[MAX_PATH*2 + sizeof(UNICODE_STRING)]:CHAR
Local               ObjAttr:OBJECT_ATTRIBUTES
Local               File:HANDLE, Section:HANDLE
Local               IoStatus:IO_STATUS_BLOCK
Local               ViewSize:ULONG
	push NULL
	push sizeof(UNICODE_STRING) + 2*MAX_PATH
	lea  eax, FileU
	push eax
	push MemoryMappedFilenameInformation
	push pImage
	push NtCurrentProcess
	%PCALL CRC_NT_QUERY_VIRTUAL_MEMORY, 6
	.if  !Eax
		mov  ObjAttr.uLength,                   sizeof(OBJECT_ATTRIBUTES)
		mov  ObjAttr.uAttributes,               OBJ_CASE_INSENSITIVE
		lea  ecx,                               FileU
		mov  ObjAttr.hRootDirectory,            eax
		mov  ObjAttr.pObjectName,               ecx
		mov  ObjAttr.pSecurityDescriptor,       eax
		mov  ObjAttr.pSecurityQualityOfService, eax
		lea  eax,                               IoStatus
		lea  ecx,                               ObjAttr
		lea  edx,                               File
		push 60H
		push 5
		push eax
		push ecx
		push 100020H
		push edx
		%PCALL CRC_NT_OPEN_FILE, 6
		.if  !Eax
			lea  ecx, Section
			push File
			push 1000000H
			push 10H
			push NULL
			push NULL
			push 0FH
			push ecx
			%PCALL CRC_NT_CREATE_SECTION, 7
			.if  !Eax
				mov  ViewSize, eax
				lea  ecx,      ViewSize
				push Access
				push Eax
				push ViewShare
				push Ecx
				push Eax
				push Eax
				push Eax
				push ViewBase
				push NtCurrentProcess
				push Section
				%PCALL CRC_NT_MAP_VIEW_OF_SECTION, 10
				push eax                ; STATUS_SUCCESS/STATUS_IMAGE_NOT_AT_BASE
				push Section
				%PCALL CRC_NT_CLOSE, 1
				pop  eax
			.endif
			push eax
			push File
			%PCALL CRC_NT_CLOSE, 1
			pop  eax
		.endif
	.endif
	ret
PeMapView endp

; +
;
PeRelocate proc uses ebx esi edi Image:PVOID, RE:PVOID, RW:PVOID, RvaBase:ULONG, RvaLimit:ULONG, RelMap:PVOID
	mov    eax, Image
	add    eax, IMAGE_DOS_HEADER.e_lfanew[eax]
	mov    esi, IMAGE_NT_HEADERS.OptionalHeader.DataDirectory.VirtualAddress[eax[IMAGE_DIRECTORY_ENTRY_BASERELOC*sizeof(IMAGE_DATA_DIRECTORY)]]
	mov    edi, IMAGE_NT_HEADERS.OptionalHeader.DataDirectory._Size[eax[IMAGE_DIRECTORY_ENTRY_BASERELOC*sizeof(IMAGE_DATA_DIRECTORY)]]
	add    esi, Image
	add    edi, esi                                                                                                                             ; Limit
	assume esi:PIMAGE_BASE_RELOCATION
	.repeat
		mov ebx, [esi].SizeOfBlock
		sub ebx, sizeof(IMAGE_BASE_RELOCATION)
		shr ebx, 1
		
		mov edx, RE
		sub edx, Image
		sub edx, RvaBase
		mov eax, RelMap
		.repeat
			movzx ecx, WORD PTR[esi][ebx*2][sizeof(IMAGE_BASE_RELOCATION) - 2]
			.if   Ecx
;				IMAGE_REL_BASED_HIGHLOW << 12
				and ecx, PAGE_SIZE - 1
				add ecx, [esi].VirtualAddress            ; RVA
				.if (RvaBase <= Ecx) && (RvaLimit > Ecx)
					sub ecx,            RvaBase
					bts DWORD PTR[eax], ecx
					add ecx,            RW
					add DWORD PTR[ecx], edx
				.endif
			.endif
			dec ebx
		.until Zero?
		add    esi, [esi].SizeOfBlock
	.until Esi >= Edi
	xor    eax, eax
	ret
PeRelocate endp

; 
;
PeMap proc uses ebx esi edi Section:PHANDLE, RE:PPVOID, FR:PVOID
Local S1ze:ULONG, Rva:RANGE, RW:PVOID, FW:PVOID
Local      Relocs:HANDLE

    assume fs:nothing
    mov    eax, fs:[30h]            ; Get PEB
    mov    ebx, DWORD PTR [eax + 8] ; Get ImageBaseAddress from PEB
    
    ; Get NT headers
    mov edx, ebx
    add edx, DWORD PTR[ebx + 3Ch] ; e_lfanew
    
    ; Get SizeOfCode and BaseOfCode
 
	mov ecx, IMAGE_NT_HEADERS.OptionalHeader.SizeOfCode[edx]
	mov edx, IMAGE_NT_HEADERS.OptionalHeader.BaseOfCode[edx]

    mov S1ze,      ecx
    mov Rva.Base,  edx
    lea esi,       [ebx + edx]
    add edx,       ecx
    mov Rva.Limit, edx
    
    xor eax, eax
    mov RW,  eax
    mov FW,  eax
    
    ; Map relocation section
    mov  ecx, S1ze
    shr  ecx, 3
    invoke MmMap, addr Relocs, ecx, FR, addr FW
    test eax, eax
    jnz  Error
    
    ; Map code section
    invoke MmMap, Section, S1ze, RE, addr RW
    test eax, eax
    jnz  CleanupRelocs
    
    ; Copy code
    mov ecx, S1ze
    shr ecx, 2
    mov edi, RW
    mov esi, [RE]
    rep movsd
    
    ; Relocate
    invoke PeRelocate, ebx, dword ptr [RE], RW, Rva.Base, Rva.Limit, FW
    
    ; Unmap RW view
    mov  edx, RW
    call PepUnmap
    jmp  CleanupRelocs

Error:
    xor eax, eax
    jmp Exit

CleanupRelocs:
    mov  edx, Relocs
    call PepClose
    mov  edx, FW
    call PepUnmap

Exit:
    ret

PepUnmap:
    push eax
    push edx
    push -1                     ; NtCurrentProcess
    call [NtUnmapViewOfSection]
    pop  eax
    retn

PepClose:
    push eax
    push edx
    call [NtClose]
    pop  eax
    retn

PeMap endp