KERNEL_USER_TIMES STRUCT
    CreateTime QWORD ?
    ExitTime   QWORD ?
    KernelTime QWORD ?
    UserTime   QWORD ?
KERNEL_USER_TIMES ENDS



; +
;
TsGetState        proc Tid:ULONG
Local             Cid:CLIENT_ID
Local             Thread:HANDLE
Local             Obj:OBJECT_ATTRIBUTES
Local             Times:KERNEL_USER_TIMES
    xor eax,                           eax
    mov ecx,                           Tid
    mov Obj.uLength,                   sizeof(OBJECT_ATTRIBUTES)
    mov Obj.hRootDirectory,            eax
    mov Obj.uAttributes,               eax
    mov Obj.pSecurityDescriptor,       eax
    mov Obj.pSecurityQualityOfService, eax
    mov Obj.pObjectName,               eax
    mov Cid.UniqueProcess,             eax
    mov Cid.UniqueThread,              ecx
    
    lea  eax, Cid
    lea  ecx, Obj
    lea  edx, Thread
    push eax
    push ecx
    push THREAD_QUERY_INFORMATION
    push edx
    %PCALL CRC_NT_OPEN_THREAD, 4
    .if  !Eax
        lea  eax, Times
        push NULL
        push sizeof(KERNEL_USER_TIMES)
        push eax
        push 0                         ; ThreadTimes information class
        push Thread
        %PCALL CRC_NT_QUERY_INFORMATION_THREAD, 5
        .if  !Eax
            mov eax, DWORD PTR [Times.ExitTime]
            mov edx, DWORD PTR [Times.ExitTime + 4]
        .endif
        push edx
        push eax
        push Thread
        %PCALL CRC_NT_CLOSE, 1
        pop  eax
    .endif
    ret
TsGetState endp
; +
;
TsCleaning proc uses ebx esi edi
	%ENVP Ebx
	xor    esi, esi          ; N
	mov    edi, [ebx].TsBase
	assume edi:PTLS
	.repeat
		bt  DWORD PTR [ebx].TsMap, esi
		.if Carry?
			invoke TsGetState, [Edi].Tid
			.if    Eax
				lock bts DWORD PTR [ebx].TsMap, esi
			.endif
		.endif
		inc esi
		add edi, sizeof(TLS)
	.until Esi > 256
	ret
TsCleaning endp

; +
; o Initial all bits set to 1.
;
	assume ebx:PENV
TsQueryWorkSpace proc
Scan:
	xor ecx, ecx         ; N
	lea edx, [ebx].TsMap
@@:
	bsf eax, DWORD PTR[edx][ecx*4]
	.if Zero?
		inc    ecx
		cmp    ecx, 8
		jb     @b
		invoke TsCleaning
		jmp    Scan
	.else
		lock btr DWORD PTR[edx][ecx*4], eax
		jnc      Scan
		; P = N*32 + I
		shl      ecx,                   5
		add      eax,                   ecx
	.endif
	ret
TsQueryWorkSpace endp

; +
;
TsAlloc          proc uses ebx esi edi
	%ENVP Ebx
	invoke TsQueryWorkSpace
	push   eax
	
	imul   eax, sizeof(TLS)
	add    eax, [ebx].TsBase
	mov    esi, eax
	assume esi:PTLS
	
	mov edi, eax
	mov ecx, sizeof(TLS)/4
	cld
	xor eax, eax
	rep stosd
	
	lea ecx,         [esi].Store
	add ecx,         OPT_STACK_SIZE
	mov [esi].Stack, ecx
	
	mov edx,       fs:[TEB.ClientId.UniqueThread]
	pop [esi].TsI
	mov [esi].Tid, edx

	mov DWORD PTR fs:[DTLS], esi
	mov eax,                 esi
	ret
TsAlloc endp

; +
;
TsGet   proc
	%TLSP Eax
	.if !Eax
		invoke TsAlloc
	.endif
	ret
TsGet endp