@echo off
setlocal EnableDelayedExpansion

set "MASM32=C:\masm32\64"
set "PATH=%MASM32%\bin;%PATH%"
set "SOURCE_FILE=cb.asm"
set "OBJECT_FILE=cb.obj"
set "OUTPUT_FILE=cb.exe"

echo Building %SOURCE_FILE%...

C:\masm32\64\ml64.exe /c /coff "%SOURCE_FILE%"
if %ERRORLEVEL% neq 0 (
    echo Assembly failed with error %ERRORLEVEL%
    goto error
)

echo Linking %OBJECT_FILE%...

link /SUBSYSTEM:WINDOWS "%OBJECT_FILE%"
if %ERRORLEVEL% neq 0 (
    echo Linking failed with error %ERRORLEVEL%
    goto error
)

echo Cleaning up...

del "%OBJECT_FILE%"

echo Build successful! Output: %OUTPUT_FILE%
goto end

:error
echo Build failed!

:end
endlocal
pause