@echo off
setlocal EnableDelayedExpansion

set "MASM32=C:\masm32\32"
set "PATH=%MASM32%\bin;%PATH%"
set "SOURCE_FILE=cb.asm"
set "OBJECT_FILE=cb.obj"
set "OUTPUT_FILE=cb.exe"
set "PDB_FILE=cb.pdb"  

echo Building %SOURCE_FILE%...

C:\masm32\32\ml.exe /c /coff /Zi /Fd "%PDB_FILE%" "%SOURCE_FILE%"
if %ERRORLEVEL% neq 0 (
    echo Assembly failed with error %ERRORLEVEL%
    goto error
)

echo Linking %OBJECT_FILE%...

C:\masm32\32\link.exe /SUBSYSTEM:WINDOWS /DEBUG /PDB:"%PDB_FILE%" "%OBJECT_FILE%"
if %ERRORLEVEL% neq 0 (
    echo Linking failed with error %ERRORLEVEL%
    goto error
)

echo Cleaning up...

del "%OBJECT_FILE%"

echo Build successful! Output: %OUTPUT_FILE%
goto end

:error
echo Build failed!

:end
endlocal
pause