extrn printf:PROC
FILE_NON_DIRECTORY_FILE  EQU 00000040h
FILE_SHARE_READ         EQU 1
FILE_SHARE_WRITE EQU 2
FILE_APPEND_DATA        EQU 00000004h
FILE_SYNCHRONOUS_IO_NONALERT EQU 00000020h

.data
g_LogU DB MAX_PATH DUP (?)
g_Log  DWORD ?

.code

LgNew PROC USES esi edi ebx $Log:PTR BYTE
    LOCAL LogU:UNICODE_STRING
    LOCAL OA:OBJECT_ATTRIBUTES
    LOCAL Io:IO_STATUS_BLOCK
    LOCAL Log:DWORD
    LOCAL BufferLog[MAX_PATH]:BYTE
    
    invoke RtlCreateUnicodeStringFromAsciiz, ADDR LogU, $Log
    invoke RtlDosPathNameToNtPathName_U, ADDR BufferLog, ADDR g_LogU, NULL, NULL
    
    xor eax, eax
    lea ecx, g_LogU
    mov OA.uLength, SIZEOF OBJECT_ATTRIBUTES
    mov OA.hRootDirectory, eax
    mov OA.uAttributes, eax
    mov OA.pSecurityDescriptor, eax
    mov OA.pSecurityQualityOfService, eax
    mov OA.pObjectName, ecx
    
    invoke ZwCreateFile, ADDR Log, FILE_ALL_ACCESS, ADDR OA, ADDR Io, 0, FILE_ATTRIBUTE_NORMAL, 0, FILE_OVERWRITE_IF, FILE_RANDOM_ACCESS, NULL, 0
    
    push eax
    invoke RtlFreeUnicodeString, ADDR LogU
    pop eax
    
    .IF eax == 0
        invoke ZwClose, Log
    .ENDIF
    
    ret
LgNew ENDP



DebugMsg4 db "LgAdd: Attempting to write %d bytes: %s", 0Ah, 0
DebugMsg5 db "LgAdd: ZwWriteFile result: %d", 0Ah, 0


LgAdd PROC USES esi edi ebx Msg:PTR BYTE, S1ze:DWORD
    LOCAL OA:OBJECT_ATTRIBUTES
    LOCAL Log:PVOID
    LOCAL File:FILE_STANDARD_INFORMATION
    LOCAL Io:IO_STATUS_BLOCK
    LOCAL Status:DWORD
    
    ; ; Debug print
    ; push S1ze
    ; push Msg
    ; push OFFSET DebugMsg4
    ; call printf
    ; add esp, 12
    
    xor eax, eax
    lea ecx, g_LogU
    mov OA.uLength, SIZEOF OBJECT_ATTRIBUTES
    mov OA.hRootDirectory, eax
    mov OA.uAttributes, OBJ_CASE_INSENSITIVE
    mov OA.pSecurityDescriptor, eax
    mov OA.pSecurityQualityOfService, eax
    mov OA.pObjectName, ecx
    
    invoke ZwOpenFile, ADDR Log, FILE_APPEND_DATA, ADDR OA, ADDR Io, FILE_SHARE_READ or FILE_SHARE_WRITE, FILE_NON_DIRECTORY_FILE or FILE_SYNCHRONOUS_IO_NONALERT
    mov Status, eax
    
    .IF eax == 0
        invoke ZwWriteFile, Log, 0, NULL, NULL, ADDR Io, Msg, S1ze, NULL, NULL
        mov Status, eax
        
        push eax
        invoke ZwClose, Log
        pop eax
    .ENDIF
    
    ; Debug print
    push Status
    push OFFSET DebugMsg5
    call printf
    add esp, 8
    
    mov eax, Status
    ret
LgAdd ENDP

PsGetName PROC USES esi edi ebx Pid:DWORD, $Name:PTR BYTE
    LOCAL Cid:CLIENT_ID
    LOCAL Process:DWORD
    LOCAL Reql:DWORD
    LOCAL Ps[MAX_PATH*2]:BYTE
    
    invoke ZwQueryInformationProcess, -1, ProcessImageFileName, ADDR Ps, MAX_PATH*2, ADDR Reql
    
    .IF eax == 0
        mov esi, DWORD PTR [Ps]        ; Buffer
        mov edi, $Name
        movzx ecx, WORD PTR [Ps+2]     ; Length (16-bit)
        add esi, ecx
        mov eax, '\'
        std
        repne scasw
        cld
        add esi, 4
        not cx
        movzx edx, WORD PTR [Ps+2]     ; Length (16-bit)
        add cx, dx
        movzx edx, cx                  ; Ensure edx is 32-bit
        .REPEAT
            lodsw
            stosb
            dec edx
        .UNTIL edx == 0
        lea eax, [edx-1]
    .ELSE
        xor eax, eax
    .ENDIF
    
    ret
PsGetName ENDP

$Format DB "0x%X_%s_.log", 0

DebugMsg1 db "Formatted string length: %d", 0Ah, 0
DebugMsg2 db "Formatted string: %s", 0Ah, 0
DebugMsg3 db "LgAdd result: %d", 0Ah, 0

LgPrint PROC
    LOCAL Buffer[MAX_PATH]:BYTE
    LOCAL _Length:DWORD
    
    push ebx
    push esi
    push edi

    mov ebx, fs:[18h]
    mov ebx, DWORD PTR [ebx+24h]  ; Get process ID
    
    lea eax, [ebp+8]    ; Get address of format string arguments
    push eax
    push ebx            ; Push process ID
    push OFFSET $Format
    lea eax, Buffer
    push eax            ; Push address of Buffer
    call wsprintfA
    mov _Length, eax     ; Save the length of the formatted string
    add esp, 16

    ; Print debug information
    push _Length
    push OFFSET DebugMsg1
    call printf
    add esp, 8

    ; Print the formatted buffer
    lea eax, Buffer
    push eax            ; Push address of Buffer
    push OFFSET DebugMsg2
    call printf
    add esp, 8

    push _Length         ; Push length of formatted string
    lea ecx, Buffer
    push ecx            ; Push address of Buffer
    call LgAdd
    add esp, 8

    ; Print result of LgAdd
    push eax
    push OFFSET DebugMsg3
    call printf
    add esp, 8

    pop edi
    pop esi
    pop ebx
    ret


LgPrint ENDP


LgInit PROC
    LOCAL $Ps[MAX_PATH]:BYTE
    LOCAL $Log[MAX_PATH]:BYTE
    LOCAL CidValue:DWORD
    
    push ebx
    mov ebx, fs:[18h]
    mov ebx, dword ptr [ebx+24h]  ; Get process ID
    mov CidValue, ebx
    
    lea eax, $Ps
    push eax
    push CidValue
    call PsGetName
    add esp, 8
    
    lea eax, $Ps
    push eax
    push CidValue
    push OFFSET $Format
    lea eax, $Log
    push eax
    call wsprintfA
    add esp, 16
    
    lea eax, $Log
    push eax
    call LgNew
    add esp, 4
    
    pop ebx
    ret
LgInit ENDP
